import { Room } from "./room";
import { Connection } from "./connection";
import { CreatedRoom, ParticipantRole, UserId, UserNickname, WaitingRoomUpdate } from "./constants";
export declare class RoomExtended extends Room {
    constructor(connection: Connection, pc: RTCPeerConnection, name: string, pin: string, nickname: string);
    createRoom(): Promise<CreatedRoom>;
    sendControlMessage(to: UserNickname, msg: string, broadcast: boolean): Promise<void>;
    authorizeWaitingList(userId: UserId, authorized: boolean): Promise<void>;
    moveToWaitingRoom(nickname: UserNickname): Promise<void>;
    configureWaitingRoom(enabled: boolean): Promise<WaitingRoomUpdate>;
    assignRole(nickname: UserNickname, role: ParticipantRole): Promise<void>;
    subscribeToWaitingParticipant(nickname: UserNickname): Promise<void>;
    unsubscribeFromWaitingParticipant(nickname: UserNickname): Promise<void>;
}
