"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _SfuExtended_instances, _SfuExtended_connection, _SfuExtended__user, _SfuExtended__server, _SfuExtended__state, _SfuExtended_rooms, _SfuExtended_notifier, _SfuExtended_createConnection, _SfuExtended_emmitAction, _SfuExtended_emmitBinaryAction, _SfuExtended_checkAuthenticated;
Object.defineProperty(exports, "__esModule", { value: true });
exports.SfuExtended = void 0;
const uuid_1 = require("uuid");
const promises_1 = __importDefault(require("./promises"));
const connection_1 = require("./connection");
const constants_1 = require("./constants");
const notifier_1 = require("./notifier");
const room_extended_1 = require("./room-extended");
const logger_1 = __importStar(require("./logger"));
class SfuExtended {
    constructor() {
        _SfuExtended_instances.add(this);
        _SfuExtended_connection.set(this, void 0);
        _SfuExtended__user.set(this, void 0);
        _SfuExtended__server.set(this, void 0);
        _SfuExtended__state.set(this, constants_1.State.NEW);
        _SfuExtended_rooms.set(this, {});
        //TODO(naz): Provide union instead of InternalMessage
        _SfuExtended_notifier.set(this, new notifier_1.Notifier());
        logger_1.default.setVerbosity(logger_1.Verbosity.ERROR);
    }
    connect(options) {
        if (!options) {
            throw new TypeError("No options provided");
        }
        const connectionConfig = {
            url: options.url,
            appName: constants_1.InternalApi.Z_APP,
            timeout: options.timeout ? options.timeout : 10000,
            custom: {
                username: options.username,
                password: options.password,
                nickname: options.nickname
            }
        };
        const self = this;
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_createConnection).call(this);
        __classPrivateFieldSet(this, _SfuExtended__server, new URL(options.url).hostname, "f");
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                const userCredentials = yield __classPrivateFieldGet(this, _SfuExtended_connection, "f").connect(connectionConfig);
                __classPrivateFieldSet(self, _SfuExtended__user, {
                    username: userCredentials.sipLogin,
                    nickname: userCredentials.sipVisibleName,
                    pmi: userCredentials.pmi
                }, "f");
                __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.AUTHENTICATED, "f");
                __classPrivateFieldGet(self, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONNECTED);
                resolve(__classPrivateFieldGet(self, _SfuExtended__user, "f"));
            }
            catch (e) {
                __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.FAILED, "f");
                __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.FAILED, e);
                reject(e);
            }
        }));
    }
    ;
    sendMessage(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(self);
            if (!msg) {
                reject(new Error("Can't send null message"));
            }
            else if ((!msg.body || msg.body === "") && (!msg.attachments || msg.attachments.length === 0)) {
                reject(new Error("Can't send message without content"));
            }
            else if (!msg.chatId || msg.chatId === "") {
                reject(new Error("Can't send message without a chatId"));
            }
            else {
                __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.SEND_MESSAGE, {
                    body: msg.body,
                    chatId: msg.chatId,
                    attachments: msg.attachments
                }, resolve, reject);
            }
        });
    }
    ;
    sendMessageAttachments(attachments) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            if (attachments.length) {
                for (let i = 0; i < attachments.length; i++) {
                    const { size, payload } = attachments[i];
                    const data = new Blob([payload]);
                    const chunks = Math.ceil(size / constants_1.ATTACHMENT_CHUNK_SIZE);
                    const id = attachments[i].id;
                    for (let i = 0; i < chunks; i++) {
                        let end = 0;
                        if (i === chunks - 1) {
                            end = 1;
                        }
                        /**
                         * 3-bytes header:
                         * 1st byte - command (10 - sendMessageAttachment)
                         * 2nd byte - attachment id
                         * 3rd byte - end of attachment
                         * @type {Uint8Array}
                         */
                        const header = new Uint8Array([10, id, end]);
                        const start = i * constants_1.ATTACHMENT_CHUNK_SIZE;
                        const chunk = new Blob([header, data.slice(start, start + constants_1.ATTACHMENT_CHUNK_SIZE)]);
                        __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitBinaryAction).call(self, chunk);
                    }
                }
                resolve();
            }
            else {
                reject(new Error("No attachments"));
            }
        });
    }
    getMessageAttachment(attachment) {
        const { id, name, messageId, chatId } = attachment;
        if (!messageId || messageId === '') {
            throw new Error('Empty messageId');
        }
        if (!chatId || chatId === '') {
            throw new Error('Empty chatId');
        }
        if (!name || name === '') {
            throw new Error('Empty attachment name');
        }
        if (!id || id === '') {
            throw new Error('Empty attachment id');
        }
        // Todo (igor): return Promise
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(this, constants_1.InternalApi.GET_ATTACHMENT, {
            messageId: messageId,
            chatId: chatId,
            id: id,
            name: name,
            size: constants_1.ATTACHMENT_CHUNK_SIZE
        }, () => { }, () => { });
    }
    markMessageRead(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            if (!msg) {
                reject(new Error("Can't mark null message"));
            }
            else if (!msg.chatId || msg.chatId === "") {
                reject(new Error("Can't mark message without a chatId"));
            }
            else if (!msg.id || msg.id === "") {
                reject(new Error("Can't mark message without massage id"));
            }
            else {
                __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.MARK_MESSAGE_READ, {
                    id: msg.id,
                    chatId: msg.chatId
                }, resolve, reject);
            }
        });
    }
    markMessageUnread(msg) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            if (!msg) {
                reject(new Error("Can't mark null message"));
            }
            else if (!msg.chatId || msg.chatId === "") {
                reject(new Error("Can't mark message without a chatId"));
            }
            else if (!msg.id || msg.id === "") {
                reject(new Error("Can't mark message without massage id"));
            }
            else {
                __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.MARK_MESSAGE_UNREAD, {
                    id: msg.id,
                    chatId: msg.chatId
                }, resolve, reject);
            }
        });
    }
    getUserList() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_USER_LIST, {}, resolve, reject);
        });
    }
    ;
    getUserCalendar() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_USER_CALENDAR, {}, resolve, reject);
        });
    }
    ;
    addCalendarEvent(event) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_CALENDAR_EVENT, {
                event: event
            }, resolve, reject);
        });
    }
    ;
    removeCalendarEvent(event) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CALENDAR_EVENT, {
                event: event
            }, resolve, reject);
        });
    }
    ;
    getUserChats() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_USER_CHATS, {}, resolve, reject);
        });
    }
    ;
    getPublicChannels() {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.GET_PUBLIC_CHANNELS, {}, resolve, reject);
        });
    }
    ;
    loadChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.LOAD_CHAT, { id: chat.id }, resolve, reject);
        });
    }
    ;
    createChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CREATE_CHAT, {
                id: chat.id,
                name: chat.name,
                members: chat.members,
                favourite: chat.favourite,
                channel: chat.channel,
                channelType: chat.channelType,
                channelSendPolicy: chat.channelSendPolicy,
                sendPermissionList: chat.sendPermissionList
            }, resolve, reject);
        });
    }
    ;
    deleteChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.DELETE_CHAT, { id: chat.id }, resolve, reject);
        });
    }
    ;
    renameChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.RENAME_CHAT, { id: chat.id, name: chat.name }, resolve, reject);
        });
    }
    ;
    addMemberToChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_MEMBER_TO_CHAT, { id: chat.id, member: chat.member }, resolve, reject);
        });
    }
    ;
    removeMemberFromChat(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_MEMBER_FROM_CHAT, { id: chat.id, member: chat.member }, resolve, reject);
        });
    }
    ;
    inviteContact(invite) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.INVITE_CONTACT, { from: __classPrivateFieldGet(self, _SfuExtended__user, "f").username, to: invite.to }, resolve, reject);
        });
    }
    addContactToFavourites(contact) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_CONTACT_TO_FAVOURITES, { id: contact.id }, resolve, reject);
        });
    }
    removeContactFromFavourites(contact) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CONTACT_FROM_FAVOURITES, { id: contact.id }, resolve, reject);
        });
    }
    confirmContact(invite) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.CONFIRM_CONTACT, { from: invite.from, to: invite.to, id: invite.id }, resolve, reject);
        });
    }
    removeContact(contact) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CONTACT, { id: contact.id }, resolve, reject);
        });
    }
    updateChannelSendPolicy(channel) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.UPDATE_CHANNEL_SEND_POLICY, {
                id: channel.id,
                channelSendPolicy: channel.channelSendPolicy
            }, resolve, reject);
        });
    }
    addChannelSendPermissionListMember(channel) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_CHANNEL_SEND_PERMISSION_LIST_MEMBER, {
                id: channel.id,
                member: channel.member
            }, resolve, reject);
        });
    }
    removeChannelSendPermissionListMember(channel) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CHANNEL_SEND_PERMISSION_LIST_MEMBER, {
                id: channel.id,
                member: channel.member
            }, resolve, reject);
        });
    }
    updateChatConfiguration(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.UPDATE_CHAT_CONFIGURATION, chat, resolve, reject);
        });
    }
    addChatToFavourites(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.ADD_CHAT_TO_FAVOURITES, { id: chat.id }, resolve, reject);
        });
    }
    removeChatFromFavourites(chat) {
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const self = this;
        return new Promise(function (resolve, reject) {
            __classPrivateFieldGet(self, _SfuExtended_instances, "m", _SfuExtended_emmitAction).call(self, constants_1.InternalApi.REMOVE_CHAT_FROM_FAVOURITES, { id: chat.id }, resolve, reject);
        });
    }
    createRoom(options) {
        if (!options) {
            throw new TypeError("No options provided");
        }
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        const nickname = options.nickname || __classPrivateFieldGet(this, _SfuExtended__user, "f").nickname;
        const room = new room_extended_1.RoomExtended(__classPrivateFieldGet(this, _SfuExtended_connection, "f"), options.pc, options.name, options.pin, nickname);
        __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[room.name()] = room;
        const self = this;
        const cleanup = () => {
            __classPrivateFieldGet(self, _SfuExtended_rooms, "f")[room.name()].pc().close();
            __classPrivateFieldGet(self, _SfuExtended_rooms, "f")[room.name()].pc().dispatchEvent(new Event("connectionstatechange"));
            delete __classPrivateFieldGet(self, _SfuExtended_rooms, "f")[room.name()];
        };
        room.on(constants_1.RoomEvent.LEFT, function (participant) {
            if (participant.name === __classPrivateFieldGet(self, _SfuExtended__user, "f").nickname) {
                cleanup();
            }
        }).on(constants_1.RoomEvent.EVICTED, function (participant) {
            if (participant.name === __classPrivateFieldGet(self, _SfuExtended__user, "f").nickname) {
                cleanup();
            }
        }).on(constants_1.RoomEvent.FAILED, cleanup).on(constants_1.RoomEvent.OPERATION_FAILED, function (e) {
            if (constants_1.Operations.ROOM_JOIN === e.operation) {
                cleanup();
            }
        });
        return room;
    }
    ;
    getRoom(options) {
        if (!options) {
            throw new TypeError("No options provided");
        }
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_checkAuthenticated).call(this);
        return __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[options.name];
    }
    disconnect() {
        for (const [key, value] of Object.entries(__classPrivateFieldGet(this, _SfuExtended_rooms, "f"))) {
            value.leaveRoom();
        }
        __classPrivateFieldSet(this, _SfuExtended__user, undefined, "f");
        __classPrivateFieldGet(this, _SfuExtended_connection, "f").close();
        __classPrivateFieldGet(this, _SfuExtended_instances, "m", _SfuExtended_createConnection).call(this);
        __classPrivateFieldSet(this, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
        __classPrivateFieldSet(this, _SfuExtended_rooms, {}, "f");
    }
    ;
    user() {
        return __classPrivateFieldGet(this, _SfuExtended__user, "f");
    }
    server() {
        return __classPrivateFieldGet(this, _SfuExtended__server, "f");
    }
    state() {
        return __classPrivateFieldGet(this, _SfuExtended__state, "f");
    }
    on(event, callback) {
        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").add(event, callback);
        return this;
    }
    ;
    off(event, callback) {
        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").remove(event, callback);
        return this;
    }
    ;
}
exports.SfuExtended = SfuExtended;
_SfuExtended_connection = new WeakMap(), _SfuExtended__user = new WeakMap(), _SfuExtended__server = new WeakMap(), _SfuExtended__state = new WeakMap(), _SfuExtended_rooms = new WeakMap(), _SfuExtended_notifier = new WeakMap(), _SfuExtended_instances = new WeakSet(), _SfuExtended_createConnection = function _SfuExtended_createConnection() {
    const self = this;
    __classPrivateFieldSet(this, _SfuExtended_connection, new connection_1.Connection((name, data) => {
        switch (name) {
            case constants_1.InternalApi.DEFAULT_METHOD:
                //filter messages
                //TODO(naz): refactor this part
                if (data[0].type === constants_1.InternalApi.MESSAGE) {
                    const message = data[0].message;
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.MESSAGE, message);
                }
                else if (data[0].type === constants_1.InternalApi.MESSAGE_STATE) {
                    const messageState = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, messageState.status)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.MESSAGE_STATE, messageState.status);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.USER_LIST) {
                    const userList = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, userList.list);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.USER_LIST, userList.list);
                }
                else if (data[0].type === constants_1.InternalApi.USER_CALENDAR) {
                    const calendar = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, calendar.calendar);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.USER_CALENDAR, calendar.calendar);
                }
                else if (data[0].type === constants_1.InternalApi.NEW_CHAT) {
                    const chatInfo = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, chatInfo.info)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.NEW_CHAT, chatInfo.info);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CONTACT_INVITE) {
                    const invite = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, invite.invite)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONTACT_INVITE, invite.invite);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CONTACT_UPDATED) {
                    const contact = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, contact.contact)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONTACT_UPDATE, contact.contact);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CONTACT_REMOVED) {
                    const contact = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, contact.contact)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CONTACT_REMOVED, contact.contact);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CHAT_DELETED) {
                    const chat = data[0];
                    if (!promises_1.default.resolve(data[0].internalMessageId, chat.info)) {
                        __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_DELETED, chat.info);
                    }
                }
                else if (data[0].type === constants_1.InternalApi.CHAT_UPDATED) {
                    const chat = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, chat.info);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_UPDATED, chat.info);
                }
                else if (data[0].type === constants_1.InternalApi.USER_CHATS) {
                    const chats = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, chats.chats);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.USER_CHATS, chats.chats);
                }
                else if (data[0].type === constants_1.InternalApi.PUBLIC_CHANNELS) {
                    const channels = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, channels.channels);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.PUBLIC_CHANNELS, channels.channels);
                }
                else if (data[0].type === constants_1.InternalApi.CHAT_LOADED) {
                    const chat = data[0];
                    promises_1.default.resolve(data[0].internalMessageId, chat.chat);
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.CHAT_LOADED, chat.chat);
                }
                else if (data[0].type === constants_1.RoomEvent.OPERATION_FAILED && promises_1.default.promised(data[0].internalMessageId)) {
                    promises_1.default.reject(data[0].internalMessageId, data[0]);
                }
                else if (data[0].type === constants_1.SfuEvent.ACK && promises_1.default.promised(data[0].internalMessageId)) {
                    promises_1.default.resolve(data[0].internalMessageId);
                }
                else if (data[0].roomName && data[0].roomName.length > 0) {
                    //room event
                    const room = __classPrivateFieldGet(this, _SfuExtended_rooms, "f")[data[0].roomName];
                    if (room) {
                        room.processEvent(data[0]);
                    }
                }
                else {
                    __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(data[0].type, data[0]);
                }
                break;
            case "failed":
                __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.FAILED, data[0]);
                break;
        }
    }, (name, data) => {
        switch (name) {
            case constants_1.InternalApi.BINARY_DATA:
                __classPrivateFieldGet(this, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.ATTACHMENT_DATA, data);
                break;
            default:
                console.error("Unknown data type " + name);
        }
    }, (e) => {
        __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.FAILED, "f");
        __classPrivateFieldGet(self, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.FAILED, e);
    }, () => {
        __classPrivateFieldSet(self, _SfuExtended__state, constants_1.State.DISCONNECTED, "f");
        self.disconnect();
        __classPrivateFieldGet(self, _SfuExtended_notifier, "f").notify(constants_1.SfuEvent.DISCONNECTED);
    }), "f");
}, _SfuExtended_emmitAction = function _SfuExtended_emmitAction(action, data, resolve, reject) {
    const id = (0, uuid_1.v4)();
    promises_1.default.add(id, resolve, reject);
    __classPrivateFieldGet(this, _SfuExtended_connection, "f").send(action, Object.assign(Object.assign({}, data), { internalMessageId: id }));
}, _SfuExtended_emmitBinaryAction = function _SfuExtended_emmitBinaryAction(data) {
    __classPrivateFieldGet(this, _SfuExtended_connection, "f").sendBinaryData(data);
}, _SfuExtended_checkAuthenticated = function _SfuExtended_checkAuthenticated() {
    if (__classPrivateFieldGet(this, _SfuExtended__state, "f") !== constants_1.State.AUTHENTICATED) {
        throw new Error("User isn't authenticated, current state " + __classPrivateFieldGet(this, _SfuExtended__state, "f"));
    }
};
//# sourceMappingURL=sfu-extended.js.map