"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Sfu_connection, _Sfu_url, _Sfu__nickname, _Sfu__state, _Sfu__room, _Sfu_notifier;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sfu = void 0;
const connection_1 = require("./connection");
const constants_1 = require("./constants");
const notifier_1 = require("./notifier");
const room_1 = require("./room");
const logger_1 = __importStar(require("./logger"));
class Sfu {
    constructor() {
        _Sfu_connection.set(this, void 0);
        _Sfu_url.set(this, void 0);
        _Sfu__nickname.set(this, void 0);
        _Sfu__state.set(this, constants_1.State.NEW);
        _Sfu__room.set(this, void 0);
        //TODO(naz): Provide union instead of InternalMessage
        _Sfu_notifier.set(this, new notifier_1.Notifier());
        logger_1.default.setVerbosity(logger_1.Verbosity.ERROR);
    }
    connect(options) {
        if (!options) {
            throw new TypeError("No options provided");
        }
        __classPrivateFieldSet(this, _Sfu_url, options.url, "f");
        __classPrivateFieldSet(this, _Sfu__nickname, options.nickname, "f");
        const connectionConfig = {
            url: options.url,
            appName: constants_1.InternalApi.P_APP,
            timeout: options.timeout ? options.timeout : 10000,
            custom: {
                nickname: options.nickname,
                //TODO(naz): rename to logGroup
                roomName: options.logGroup
            }
        };
        const self = this;
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            __classPrivateFieldSet(self, _Sfu_connection, new connection_1.Connection((name, data) => {
                switch (name) {
                    case constants_1.InternalApi.DEFAULT_METHOD:
                        if (data[0].roomName && data[0].roomName.length > 0) {
                            //room event
                            if (__classPrivateFieldGet(this, _Sfu__room, "f")) {
                                __classPrivateFieldGet(this, _Sfu__room, "f").processEvent(data[0]);
                            }
                        }
                        else {
                            __classPrivateFieldGet(this, _Sfu_notifier, "f").notify(data[0].type, data[0]);
                        }
                        break;
                    case "failed":
                        __classPrivateFieldGet(this, _Sfu_notifier, "f").notify(constants_1.SfuEvent.FAILED, data[0]);
                        break;
                }
            }, () => {
                // Supported only in sfu-extended
            }, (e) => {
                __classPrivateFieldSet(self, _Sfu__state, constants_1.State.FAILED, "f");
                __classPrivateFieldGet(self, _Sfu_notifier, "f").notify(constants_1.SfuEvent.FAILED, e);
                reject(e);
            }, () => {
                __classPrivateFieldSet(self, _Sfu__state, constants_1.State.DISCONNECTED, "f");
                __classPrivateFieldGet(self, _Sfu_notifier, "f").notify(constants_1.SfuEvent.DISCONNECTED);
            }), "f");
            yield __classPrivateFieldGet(this, _Sfu_connection, "f").connect(connectionConfig);
            __classPrivateFieldSet(self, _Sfu__state, constants_1.State.CONNECTED, "f");
            __classPrivateFieldGet(this, _Sfu_notifier, "f").notify(constants_1.SfuEvent.CONNECTED);
            resolve();
        }));
    }
    ;
    createRoom(options) {
        if (__classPrivateFieldGet(this, _Sfu__room, "f")) {
            switch (__classPrivateFieldGet(this, _Sfu__room, "f").state()) {
                case constants_1.RoomState.NEW:
                case constants_1.RoomState.JOINED:
                case constants_1.RoomState.PENDING:
                    throw new Error("Only one room at a time, already have one with state " + __classPrivateFieldGet(this, _Sfu__room, "f").state());
                case constants_1.RoomState.FAILED:
                case constants_1.RoomState.DISPOSED:
                    __classPrivateFieldSet(this, _Sfu__room, new room_1.Room(__classPrivateFieldGet(this, _Sfu_connection, "f"), options.pc, options.name, options.pin), "f");
                    break;
                default:
                    throw new Error("Unknown room state " + __classPrivateFieldGet(this, _Sfu__room, "f").state());
            }
        }
        else {
            __classPrivateFieldSet(this, _Sfu__room, new room_1.Room(__classPrivateFieldGet(this, _Sfu_connection, "f"), options.pc, options.name, options.pin), "f");
        }
        return __classPrivateFieldGet(this, _Sfu__room, "f");
    }
    disconnect() {
        if (__classPrivateFieldGet(this, _Sfu_connection, "f")) {
            __classPrivateFieldGet(this, _Sfu_connection, "f").close();
        }
    }
    room() {
        return __classPrivateFieldGet(this, _Sfu__room, "f");
    }
    nickname() {
        return __classPrivateFieldGet(this, _Sfu__nickname, "f");
    }
    state() {
        return __classPrivateFieldGet(this, _Sfu__state, "f");
    }
    on(event, callback) {
        __classPrivateFieldGet(this, _Sfu_notifier, "f").add(event, callback);
        return this;
    }
    ;
    off(event, callback) {
        __classPrivateFieldGet(this, _Sfu_notifier, "f").remove(event, callback);
        return this;
    }
    ;
}
exports.Sfu = Sfu;
_Sfu_connection = new WeakMap(), _Sfu_url = new WeakMap(), _Sfu__nickname = new WeakMap(), _Sfu__state = new WeakMap(), _Sfu__room = new WeakMap(), _Sfu_notifier = new WeakMap();
//# sourceMappingURL=sfu.js.map